diff --git a/src/bin/scripts/vacuumdb.c b/src/bin/scripts/vacuumdb.c
index 8e4e613..a320b55 100644
--- a/src/bin/scripts/vacuumdb.c
+++ b/src/bin/scripts/vacuumdb.c
@@ -668,14 +668,21 @@ run_vacuum_command(PGconn *conn, const char *sql, bool echo,
 				   const char *dbname, const char *table,
 				   const char *progname, bool async)
 {
+	int		status;
+
 	if (async)
 	{
 		if (echo)
 			printf("%s\n", sql);
 
-		PQsendQuery(conn, sql);
+		status = PQsendQuery(conn, sql);
 	}
-	else if (!executeMaintenanceCommand(conn, sql, echo))
+	else
+	{
+		status = executeMaintenanceCommand(conn, sql, echo);
+	}
+
+	if (!status)
 	{
 		if (table)
 			fprintf(stderr,
